#include "cc1000_Buffer.h"

void writeToTxBuffer(char data)
{
		TxW++;
		if(TxW >= 30) TxW = 0;
		if(TxW == TxR) //buffer overrun
		{	
			if(TxW == 0)
			{
			TxW = 29;
			}else{
			TxW--;
			}
		}else{
			tx_Buffer[(char)TxW] = data;
		}
}

char readFromTxBuffer(void)
{
		TxR++;
		if(TxR >= 30) TxR = 0;
		return tx_Buffer[(char)TxR];
}

void writeToRxBuffer(char data)
{
		/*PORTA =0x0C;
		if(RxW == 60) RxW = 0;
		rx_Buffer[RxW] = data;
		RxW++;*/
  uint8_t i;	
  RxW++;				//Move pointer to the next location
  if(RxW>=30) RxW=0;	//If behind buffer set it to 0
  
  if(RxW==RxR) {		//If read and write pointers are equal
    buffer_overrun=1;	//buffer overrun
    PORTA = 0x0C;
	RxR=RxW=0;
	/*if(RxW == 0)
	{
	RxW = 29;
	}else{
	RxW--;
	}*/
  }else{
    rx_Buffer[(int)RxW]= data;	//Write data to buffer
  }
		
}

char readFromRxBuffer(void)
{
	RxR++;				//Move pointer to the next location
  	if(RxR>=30) RxR=0;	//If behind buffer set it to 0
  	return rx_Buffer[(int)RxR];	//Read from buffer

	/*if(RxR == 60) RxR = 0;
	return rx_Buffer[RxR++];*/		
}

/* need to compute crc bevor transmit */
char tx_bufferContentSize(void)
{	
	char i;
	char volume=0;
	char factor;
	char size__ = sizeof(tx_Buffer)/sizeof(tx_Buffer[0]);
	for(i=0; i<size__; i++){
		if(tx_Buffer[i]!=0){
		volume++;
		}
	}
	factor = volume * 8;	//size * 8 = bit number
	return factor;
}

/* compute crc after receive */
char crc_bufferContentSize(void)//crc_Buffer
{
	char i;
	char volume=0;
	char factor;
	char size__ = sizeof(crc_Buffer)/sizeof(crc_Buffer[0]);
	for(i=0; i<size__; i++){
		if(crc_Buffer[i]!=0){
		volume++;
		}
	}
	factor = volume * 8;	//size * 8 = bit number
	return factor;
}
