#include "adc.h"

void ad_on(void)
{
	ADCSRA |= (1 << ADEN) | (1 << ADIE) | (1 << ADIF);
}

void ad_off(void)
{
	ADCSRA &= ~(1 << ADEN);
}

void ad_init(void)
{
	ad_off();
	/*select prescaler bits*/
	ADCSRA &= ~(1 << ADPS2)|(1 << ADPS1)|(1 << ADPS0);
}

char ad_poll(void)
{	

	ad_on();

	//ADCSRA &= ~(1 << ADIE); //disable the AD Interrupt
	ADCSRA |= (1 << ADIF);
   	ADCSRA |= (1 << ADSC) | (1 << ADIE) | (1 << ADEN);
	while (ADCSRA & (1 << ADSC));

	ad_off();

	return rssi_val;
}

char ad_output(void)
{
	ad_init();
	return ad_poll();
}

SIGNAL(SIG_ADC)
{
   rssi_val = ADCL;  
   rssi_val |= (ADCH << 8);
}
